// File used in the manage files "browse" panel
if (AJS.CRU.CREATE === undefined) {
    AJS.CRU.CREATE = {};
}
AJS.CRU.CREATE.BROWSE = {};

(function() {
    /**
     * Find a link in the directory tree by its href
     */
    var $findLink = function(href) {
        return AJS.$("#navigation-tree").find("a.pathLink[href='" + href + "']");
    };

    var moveSelectedDirTreeIds = function($newLink) {
        AJS.$("#selectedDirTreeLink, #selectedDirTreeNode").attr("id", "");
        $newLink.closest("span").attr("id", "selectedDirTreeNode");
        $newLink.attr("id", "selectedDirTreeLink");
    };

    var folderToggled = function ($linkNode) {
        // open the parents
        var $node = $findLink($linkNode.attr("href"));
        $node.parents("ul.closed,span.closed").removeClass("closed").addClass("open");
        moveSelectedDirTreeIds($node);

        AJS.$.ajax({
            type: "GET",
            url: $linkNode.attr("href").replace("edit-browse", "edit-browse-filelist"), // HACK!
            success: function(msg) {
                AJS.$("#fileResults").html(msg);
            }
        });
    };

    AJS.CRU.CREATE.BROWSE.browseDirectoryPathLinkFunction = function (event) {
        var $node = AJS.$(event.target);
        var href = $node.attr("href");
        var self = AJS.CRU.CREATE.BROWSE.browseDirectoryPathLinkFunction;
        if ($node.hasClass("browse-directory")) {
            // find the node in the tree with the same href as us
            var $selectedLink = $findLink(href);
            AJS.FECRU.BROWSE.selectLink($selectedLink, folderToggled, self);
        } else {
            AJS.FECRU.BROWSE.selectLink($node, folderToggled, self);
        }
        return false;
    };
})();