if (!AJS.FECRU) {
    AJS.FECRU = {};
    AJS.FECRU.PREFS = {};
} else if (!AJS.FECRU.PREFS) {
    AJS.FECRU.PREFS = {};
}


AJS.FECRU.PREFS.setPreference = function(name, value, callback) {
    var params = {};
    params[name] = value;
    AJS.FECRU.PREFS.setPreferences(params, callback);
};

AJS.FECRU.PREFS.setPreferences = function(prefs, callback) {
    var params = {};
    for (i in prefs) {
        params["@" + i] = prefs[i];
    }
    AJS.FECRU.AJAX.ajaxDo(fishEyePageContext + "/json/fe/setPreference.do", params, callback, false);
};

AJS.FECRU.PREFS.setupBinaryPrefLinks = function(name, cookieName, initialState, fns, onStateString, offStateString, forceInitialCall, reload) {
    var onSelector = "." + name + onStateString;
    var offSelector = "." + name + offStateString;

    function setPref(value, hideSelector, showSelector, callback) {
        AJS.FECRU.PREFS.setPreference(cookieName, value, callback);
        setVisibility(value, hideSelector, showSelector, true);
    }

    function setVisibility(value, hideSelector, showSelector, callfunction) {
        AJS.$(hideSelector).hide();
        AJS.$(showSelector).css("display","block");
        if(callfunction || forceInitialCall) {
           fns[value].call();
        }
    }

    function reloadPage() {
        if(reload) {
           window.location = window.location;
        }
    }

    AJS.$(onSelector).live("click", function() {
        setPref(onStateString, onSelector, offSelector, reloadPage);
        return false;
    });
    AJS.$(offSelector).live("click", function() {
        setPref(offStateString, offSelector, onSelector, reloadPage);
        return false;
    });
    if (initialState) {
        setVisibility(onStateString, onSelector, offSelector, false);
    } else {
        setVisibility(offStateString, offSelector, onSelector, false);
    }
};
