/* CONCAT of
/admin.js
/2static/script/cru/util.js
/2static/script/fecru/dialog.js
/2static/script/lib/jquery/plugins/jquery.tablesorter-2.0.3.min.js
/2static/script/lib/jquery/plugins/jquery.metadata-2.0.min.js
/2static/script/lib/jquery/plugins/jquery.scrollTo.js
*/
/* START /admin.js */
if (AJS.FE === undefined) {
    AJS.FE = {};
}
if (AJS.FE.ADMIN === undefined) {
    AJS.FE.ADMIN = {};
}

(function() {

    AJS.FE.ADMIN.urlBase = function () {
        return fishEyePageContext + '/admin/';
    };

    AJS.$(document).ready(function() {
        AJS.$("#createArchiveButton").click(function() {
            AJS.FE.ADMIN.createBackupDialog();
            return false;
        });
        AJS.$("#disableCheckbox").click(function() {
            AJS.FE.ADMIN.toggleEditScheduledBackupsProperties();
            return true;
        });
    });

    AJS.FE.ADMIN.createBackupDialog = function () {

        var url = AJS.FE.ADMIN.urlBase() + "backupprogress.do?";
        AJS.$.each(AJS.$("#backupItemSelection :checkbox:checked"), function() {
            url += "includeItems=" + this.value + "&";
        });
        if (AJS.$(".adminTable #path")) {
            url += "path=" + AJS.$(".adminTable #path").attr("value");
        }
        // Create the popup:
        AJS.FECRU.DIALOG.create(840, 550)
            .addHeader('Creating Backup')
            .addPanel('All', "<iframe id='fecru-iframe' src='" + url +
                             "' width='100%' height='100%' border='0' scrolling='no' frameborder='0'>")
            .addButton('Close', function (dialog) {
                dialog.hide();
            })
            .show();
    };

    AJS.FE.ADMIN.migrateDialog = function () {

        AJS.FECRU.DIALOG.create(840, 550, "migrateDialog")
            .addHeader("Migrating Database")
            .addPanel("All", "<div id='dialogContentPane'>Loading...</div>")
            .addButton("Ok", function (dialog) {
                dialog.hide();
                window.location.reload();
            }, "okButtonDialog")
            .show();
        AJS.$(".okButtonDialog", "#migrateDialog").attr('disabled', true);

        var done = function(resp) {
            AJS.$("textarea", "#dialogContentPane").scrollTo("max");
            if (resp.finished) {
                AJS.$(".okButtonDialog", "#migrateDialog").attr('disabled', false);
            } else {
                var url = fishEyePageContext + "/setup/migrateDBProgressAjax";
                setTimeout(function() {
                    AJS.FECRU.AJAX.ajaxUpdate(url, {}, "dialogContentPane", done)},
                    1000);  // poll once per second
            }
        };

        var url = AJS.FE.ADMIN.urlBase() + "migrateDialog.do";
        var params = AJS.$("#dbform").serializeArray();
        AJS.FECRU.AJAX.ajaxUpdate(url, params, "dialogContentPane", done);
    };

    AJS.FE.ADMIN.toggleEditScheduledBackupsProperties = function () {

        var checkbox = AJS.$("#disableCheckbox");
        var inputs = AJS.$("#editPane input, #editPane select")
                .filter(':not(#disableCheckbox, #saveButton, #cancelButton)');

        if (checkbox.is(":checked")) {
            inputs.attr("disabled", true);
        } else {
            inputs.attr("disabled", false);
        }
    };
} )();

function enableAvatarFields() {
    var selection = AJS.$("#avatarForm input");
    var externalDiv = AJS.$("#externalDetails");
    var hideOrShow = function() {
        var $typeStringexternal = AJS.$("#typeStringexternal");
        if ($typeStringexternal.attr("checked")) {

            externalDiv.show();
        } else {
            externalDiv.hide();
        }
    };
    hideOrShow();
    selection.change(function(e){
         hideOrShow();
    });
}

AJS.$(document).ready(function() {
    enableAvatarFields();
});

function showRepoAttribs(repo){
    var storeDiffTrueElt = document.getElementById('repository_storeDifftrue');
    var storeDiffFalseElt = document.getElementById('repository_storeDifffalse');
    var cvsDiv = document.getElementById('cvsFields');
    var svnDiv = document.getElementById('svnFields');
    var p4Div = document.getElementById('p4Fields');
    var gitDiv = document.getElementById('gitFields');
    var selection = repo.options[repo.selectedIndex].value;
    if (selection == "cvs"){
        cvsDiv.style.display = '';
        svnDiv.style.display = 'none';
        p4Div.style.display = 'none';
        gitDiv.style.display = 'none';
        storeDiffTrueElt.disabled = true;
        storeDiffFalseElt.disabled = true;
    } else if (selection == "svn"){
        cvsDiv.style.display = 'none';
        svnDiv.style.display = '';
        p4Div.style.display = 'none';
        gitDiv.style.display = 'none';
        storeDiffTrueElt.disabled = false;
        storeDiffFalseElt.disabled = false;
    } else if (selection == "p4"){
        cvsDiv.style.display = 'none';
        svnDiv.style.display = 'none';
        p4Div.style.display = '';
        gitDiv.style.display = 'none';
        storeDiffTrueElt.disabled = false;
        storeDiffFalseElt.disabled = false;
    } else if (selection == "git") {
        cvsDiv.style.display = 'none';
        svnDiv.style.display = 'none';
        p4Div.style.display = 'none';
        gitDiv.style.display = '';
        storeDiffTrueElt.disabled = false;
        storeDiffFalseElt.disabled = false;
    } else {
        cvsDiv.style.display = 'none';
        svnDiv.style.display = 'none';
        p4Div.style.display = 'none';
        gitDiv.style.display = 'none';
        storeDiffTrueElt.disabled = false;
        storeDiffFalseElt.disabled = false;
    }
    showAdvRepoAttribs();
}

function showAdvRepoAttribs(){
    var commonAdv = document.getElementById('commonAdv');
    var cvsAdv = document.getElementById('cvsAdv');
    var svnAdv = document.getElementById('svnAdv');
    var p4Adv = document.getElementById('p4Adv');
    var gitAdv = document.getElementById('gitAdv');
    var repo = document.getElementById("repoTypeSelection");
    if (document.getElementById("advanced").value == 'Simple' /* indicates 'advanced' is selected */) {
        commonAdv.style.display='';
        var selection = repo.options[repo.selectedIndex].value;
        if (selection == "cvs"){
            cvsAdv.style.display = '';
            svnAdv.style.display = 'none';
            p4Adv.style.display = 'none';
            gitAdv.style.display = 'none';
        } else if (selection == "svn"){
            cvsAdv.style.display = 'none';
            svnAdv.style.display = '';
            p4Adv.style.display = 'none';
            gitAdv.style.display = 'none';
        } else if (selection == "p4"){
            cvsAdv.style.display = 'none';
            svnAdv.style.display = 'none';
            p4Adv.style.display = '';
            gitAdv.style.display = 'none';
        } else if (selection == "git") {
            cvsAdv.style.display = 'none';
            svnAdv.style.display = 'none';
            p4Adv.style.display = 'none';
            gitAdv.style.display = '';
        } else {
            cvsAdv.style.display = 'none';
            svnAdv.style.display = 'none';
            p4Adv.style.display = 'none';
            gitAdv.style.display = 'none';
        }
    } else {
        commonAdv.style.display = 'none';
        cvsAdv.style.display = 'none';
        svnAdv.style.display = 'none';
        p4Adv.style.display = 'none';
    }
}
function svnSymDelRowEvent(a) {
    var tr = a.parentNode.parentNode;
    tr.parentNode.removeChild(tr);
    svnSymSetToCustom();
}
function svnSymAddRowEvent(stype) {
    svnSymAddRow(stype, false);
    svnSymSetToCustom();
}

function svnSymAddRow(stype, readonlyFields) {
    var tabBody = document.getElementById('svnsym' + stype);
    var idx = tabBody.getElementsByTagName("tr").length;

    var propPrefix = "svnSymbolic." + stype + "[" + idx + "]";

    var makesvnSymField = function(prop) {
        var field = document.createElement("input");
        field.type="text";
        field.name=propPrefix + prop;
        field.size="20";
        field.readOnly=readonlyFields;

        return field;
    };

    var newrow = document.createElement("tr");

    var addToRow = function(field) {
        var td = document.createElement("td");
        td.appendChild(field);
        newrow.appendChild(td);
    };

    var f1 = makesvnSymField(".regex");
    addToRow(f1);

    var f2 = makesvnSymField(".name");
    addToRow(f2);

    var f3 = makesvnSymField(".logical");
    addToRow(f3);

    var delAnchor = document.createElement("a");
    delAnchor.innerHTML = "Del";
    delAnchor.href = "#svnSymAnchor";
    delAnchor.onclick = function() { svnSymDelRowEvent(delAnchor); };
    addToRow(delAnchor);

    tabBody.appendChild(newrow);

    var result = {
            'regex': f1, 'name': f2, 'logical':f3
    };
    return result;
}

function svnSymSetToCustom() {
    var sel = document.getElementById("svnSymSelect");
    sel.value = "custom";
    svnSymTypeChange(sel);
}

function svnSymUpdateControls(body, readonly) {
    var fields = body.getElementsByTagName("input");
    for (var i = 0; i < fields.length; i++) {
        var f = fields[i];
        f.readOnly = false;
    }
}

function svnSymSetupRow(fields, reg, name, logical) {
    fields['regex'].value = reg;
    fields['name'].value = name;
    fields['logical'].value = logical;
}

function svnRemoveAllRows(svnParent) {
    var svnChildren = svnParent.rows;
    for (var i = 0; i < svnChildren.length; i++) {
        svnParent.removeChild(svnChildren[i]);
    }
}

function svnSymTypeChange(select) {
    var trunkd = document.getElementById('svnsymtrunk');
    var branchd = document.getElementById('svnsymbranch');
    var tagd = document.getElementById('svnsymtag');

    if (select.value == "custom") {
        svnSymUpdateControls(trunkd, false);
        svnSymUpdateControls(branchd, false);
        svnSymUpdateControls(tagd, false);
        return true;
    }

    svnRemoveAllRows(trunkd);
    svnRemoveAllRows(branchd);
    svnRemoveAllRows(tagd);

    if (select.value == "type1") {

        svnSymSetupRow(svnSymAddRow('trunk', true), "trunk(/|$)", "trunk", "");
        svnSymSetupRow(svnSymAddRow('branch', true), "branches/([^/]+)", "\${1}", "");
        svnSymSetupRow(svnSymAddRow('tag', true), "tags/([^/]+)", "\${1}", "");

    } else if (select.value == "type2") {

        svnSymSetupRow(svnSymAddRow('trunk', true), "([^/]+)/trunk(/|$)", "trunk", "\${1}");
        svnSymSetupRow(svnSymAddRow('branch', true), "([^/]+)/branches/([^/]+)", "\${1}-\${2}", "\${1}");
        svnSymSetupRow(svnSymAddRow('tag', true), "([^/]+)/tags/([^/]+)", "\${1}-\${2}", "\${1}");

    }
    return true;
}

// copied from crucibles global.js
function simpleSwap(toHide,toShow) {
    if (typeof(toHide) == 'object') {
        AJS.$(toHide).hide();
    } else {
        AJS.$("#"+toHide).hide();
    }
    if (typeof(toShow) == 'object') {
        AJS.$(toShow).show();
    } else {
        AJS.$("#"+toShow).show();
    }
}

// stack trace pretty

function expandStackTrace(tid) {
    toggleTrace(tid, true);
}

function collapseStackTrace(tid) {
    toggleTrace(tid, false);
}

function toggleTrace(tid, expand) {
    var expander = "#thread-"+tid+"-expander";
    var collapser = "#thread-"+tid+"-collapser";
    var stack = "#thread-"+tid;
    if (expand) {
        jQuery(expander).hide();
        jQuery(collapser).show();
        jQuery(stack).show();
    }
    else {
        jQuery(collapser).hide();
        jQuery(expander).show();
        jQuery(stack).hide();
    }
}

jQuery(document).ready(function() {
    jQuery(".stackElement", "#threaddump").each(function () {
        var traceLine = jQuery(this).text();
        if (traceLine.indexOf("cenqua") != -1|| traceLine.indexOf("atlassian") != -1) {
            jQuery(this).addClass("productCode");
            var threadId = jQuery(this.parentNode).attr("id");
            jQuery("#" + threadId + "-hl").addClass("productCodeHL");
        }
    });
});
;
/* END /admin.js */
/* START /2static/script/cru/util.js */
/**
 * Crucible utility functions that can be used from any crucible page.
 */

if (AJS.CRU === undefined) {
    AJS.CRU = {};
}
AJS.CRU.UTIL = {};

(function () {

    /**
     * Crucible base url (without trailing '/').
     *
     * @param permaId optional review id
     */
    AJS.CRU.UTIL.urlBase = function (permaId) {
        if (permaId) {
            return fishEyePageContext + '/cru/' + permaId;
        } else {
            return fishEyePageContext + '/cru';
        }
    };

    /**
     * Crucible JSON base url (without trailing '/').
     *
     * @param permaId optional review id
     */
    AJS.CRU.UTIL.jsonUrlBase = function (permaId) {
        if (permaId) {
            return fishEyePageContext + '/json/cru/' + permaId;
        } else {
            return fishEyePageContext + '/json/cru';
        }
    };
    
    AJS.CRU.UTIL.isReviewPage = function () {
        return typeof review !== 'undefined';
    };


    AJS.CRU.UTIL.startAjaxDialogSpin = function () {
        AJS.$('body').addClass('ajax-dialog');
        AJS.dim();
    };

    AJS.CRU.UTIL.stopAjaxDialogSpin = function () {
        AJS.dim();
        AJS.$('body').removeClass('ajax-dialog');
    };

    AJS.CRU.UTIL.isAjaxDialogSpinning = function () {
        return AJS.CRU.UTIL.isDimmed() && AJS.$('body').hasClass('ajax-dialog');  
    };

    AJS.CRU.UTIL.ajaxDialog = function (url, params) {
        AJS.CRU.UTIL.startAjaxDialogSpin();
        AJS.FECRU.AJAX.ajaxDo(url, params || {}, function (resp) {
            if (resp.worked) {
                if (resp.showDialog) {
                    AJS.CRU.UTIL.stopAjaxDialogSpin();
                    AJS.CRU.DIALOG.$CONTAINER.html(resp.payload);
                } else if (resp.redirect) {
                    // no need to undim
                    window.location = resp.payload;
                }
            }
            // !resp.worked handled by ajaxDo
        });
        return false;
    };

    AJS.CRU.UTIL.stateTransition = function (transition, permaId) {
        var util = AJS.CRU.UTIL;
        var url = util.jsonUrlBase(permaId) + '/changeStateAjax';
        var params = {
            command: transition
        };

        if (util.isReviewPage() && AJS.$.inArray(transition, ['action:completeReview', 'action:summarizeReview']) >= 0) {
            // If completing or summarzing we need to warn if the review has been updated.

            util.startAjaxDialogSpin();
            AJS.CRU.REVIEW.UTIL.reviewUpdatedAjax(function () {
                var reviewUpdated = AJS.$('body').hasClass('review-updated');
                if (reviewUpdated) {
                    AJS.CRU.REVIEW.UTIL.warnAboutReviewUpdates(true);
                }
                util.stopAjaxDialogSpin();
                return util.ajaxDialog(url, AJS.$.extend(params, { reviewUpdated: reviewUpdated }));
            });
            return false;

        } else {
            return util.ajaxDialog(url, params);
        }
    };

    AJS.CRU.UTIL.editDetailsFormChange = false;
    AJS.CRU.UTIL.checkEditForm = function (done) {
        if (AJS.CRU.UTIL.editDetailsFormChange) {
            AJS.CRU.REVIEW.UTIL.postEditDetailsForm(done);
        } else {
            if (done) {
                done();
            }
        }
        return false;//do a link action if called from <a>
    };

    AJS.CRU.UTIL.command = function (cmd, pid, button) {
        var perma = pid || permaId;
        if (button) {
            button.disabled = true;
        }
        var donext = function() {
            var url = AJS.CRU.UTIL.urlBase(perma);
            window.location = url + '/' + cmd;
        };
        //check and post the editDetailsForm if it has changed
        AJS.CRU.UTIL.checkEditForm(donext);
    };


    AJS.CRU.UTIL.createBlankReview = function (params) {
        var url = AJS.CRU.UTIL.jsonUrlBase() + '/createReviewDialog';
        return AJS.CRU.UTIL.ajaxDialog(url, params);
    };

    AJS.CRU.UTIL.addToReview = function (params) {
        var url = AJS.CRU.UTIL.jsonUrlBase() + '/createDialog';
        return AJS.CRU.UTIL.ajaxDialog(url, params);
    };

    AJS.CRU.UTIL.isAnyDialogShowing = function () {
        return AJS.$('body').children('div.dialog:visible').length > 0;
    };

    AJS.CRU.UTIL.isDimmed = function () {
        return !!AJS.dim.dim;
    };

})();
;
/* END /2static/script/cru/util.js */
/* START /2static/script/fecru/dialog.js */
if (!AJS.FECRU) {
    AJS.FECRU = {};
}
AJS.FECRU.DIALOG = {};

(function () {
    var safeDimensions = function (maxWidth, maxHeight, margin) {
        margin = margin || 50;
        return {
            height: Math.min(AJS.$(window).height() - margin, maxHeight),
            width: Math.min(AJS.$(window).width() - margin, maxWidth)
        };
    };

    AJS.FECRU.DIALOG.create = function (maxWidth, maxHeight, id) {
        var dimensions = safeDimensions(maxWidth, maxHeight);
        var dialog = new AJS.Dialog(dimensions.width, dimensions.height, id);
        // Add the height and width of the dialog as properties of the object
        AJS.$.extend(dialog, {width: dimensions.width, height: dimensions.height});
        return dialog;
    };
})();
;
/* END /2static/script/fecru/dialog.js */
/* START /2static/script/lib/jquery/plugins/jquery.tablesorter-2.0.3.min.js */
(function($){$.extend({tablesorter:new function(){var parsers=[],widgets=[];this.defaults={cssHeader:"header",cssAsc:"headerSortUp",cssDesc:"headerSortDown",sortInitialOrder:"asc",sortMultiSortKey:"shiftKey",sortForce:null,sortAppend:null,textExtraction:"simple",parsers:{},widgets:[],widgetZebra:{css:["even","odd"]},headers:{},widthFixed:false,cancelSelection:true,sortList:[],headerList:[],dateFormat:"us",decimal:'.',debug:false};function benchmark(s,d){log(s+","+(new Date().getTime()-d.getTime())+"ms");}this.benchmark=benchmark;function log(s){if(typeof console!="undefined"&&typeof console.debug!="undefined"){console.log(s);}else{alert(s);}}function buildParserCache(table,$headers){if(table.config.debug){var parsersDebug="";}var rows=table.tBodies[0].rows;if(table.tBodies[0].rows[0]){var list=[],cells=rows[0].cells,l=cells.length;for(var i=0;i<l;i++){var p=false;if($.metadata&&($($headers[i]).metadata()&&$($headers[i]).metadata().sorter)){p=getParserById($($headers[i]).metadata().sorter);}else if((table.config.headers[i]&&table.config.headers[i].sorter)){p=getParserById(table.config.headers[i].sorter);}if(!p){p=detectParserForColumn(table,cells[i]);}if(table.config.debug){parsersDebug+="column:"+i+" parser:"+p.id+"\n";}list.push(p);}}if(table.config.debug){log(parsersDebug);}return list;};function detectParserForColumn(table,node){var l=parsers.length;for(var i=1;i<l;i++){if(parsers[i].is($.trim(getElementText(table.config,node)),table,node)){return parsers[i];}}return parsers[0];}function getParserById(name){var l=parsers.length;for(var i=0;i<l;i++){if(parsers[i].id.toLowerCase()==name.toLowerCase()){return parsers[i];}}return false;}function buildCache(table){if(table.config.debug){var cacheTime=new Date();}var totalRows=(table.tBodies[0]&&table.tBodies[0].rows.length)||0,totalCells=(table.tBodies[0].rows[0]&&table.tBodies[0].rows[0].cells.length)||0,parsers=table.config.parsers,cache={row:[],normalized:[]};for(var i=0;i<totalRows;++i){var c=table.tBodies[0].rows[i],cols=[];cache.row.push($(c));for(var j=0;j<totalCells;++j){cols.push(parsers[j].format(getElementText(table.config,c.cells[j]),table,c.cells[j]));}cols.push(i);cache.normalized.push(cols);cols=null;};if(table.config.debug){benchmark("Building cache for "+totalRows+" rows:",cacheTime);}return cache;};function getElementText(config,node){if(!node)return"";var t="";if(config.textExtraction=="simple"){if(node.childNodes[0]&&node.childNodes[0].hasChildNodes()){t=node.childNodes[0].innerHTML;}else{t=node.innerHTML;}}else{if(typeof(config.textExtraction)=="function"){t=config.textExtraction(node);}else{t=$(node).text();}}return t;}function appendToTable(table,cache){if(table.config.debug){var appendTime=new Date()}var c=cache,r=c.row,n=c.normalized,totalRows=n.length,checkCell=(n[0].length-1),tableBody=$(table.tBodies[0]),rows=[];for(var i=0;i<totalRows;i++){rows.push(r[n[i][checkCell]]);if(!table.config.appender){var o=r[n[i][checkCell]];var l=o.length;for(var j=0;j<l;j++){tableBody[0].appendChild(o[j]);}}}if(table.config.appender){table.config.appender(table,rows);}rows=null;if(table.config.debug){benchmark("Rebuilt table:",appendTime);}applyWidget(table);setTimeout(function(){$(table).trigger("sortEnd");},0);};function buildHeaders(table){if(table.config.debug){var time=new Date();}var meta=($.metadata)?true:false,tableHeadersRows=[];for(var i=0;i<table.tHead.rows.length;i++){tableHeadersRows[i]=0;};$tableHeaders=$("thead th",table);$tableHeaders.each(function(index){this.count=0;this.column=index;this.order=formatSortingOrder(table.config.sortInitialOrder);if(checkHeaderMetadata(this)||checkHeaderOptions(table,index))this.sortDisabled=true;if(!this.sortDisabled){$(this).addClass(table.config.cssHeader);}table.config.headerList[index]=this;});if(table.config.debug){benchmark("Built headers:",time);log($tableHeaders);}return $tableHeaders;};function checkCellColSpan(table,rows,row){var arr=[],r=table.tHead.rows,c=r[row].cells;for(var i=0;i<c.length;i++){var cell=c[i];if(cell.colSpan>1){arr=arr.concat(checkCellColSpan(table,headerArr,row++));}else{if(table.tHead.length==1||(cell.rowSpan>1||!r[row+1])){arr.push(cell);}}}return arr;};function checkHeaderMetadata(cell){if(($.metadata)&&($(cell).metadata().sorter===false)){return true;};return false;}function checkHeaderOptions(table,i){if((table.config.headers[i])&&(table.config.headers[i].sorter===false)){return true;};return false;}function applyWidget(table){var c=table.config.widgets;var l=c.length;for(var i=0;i<l;i++){getWidgetById(c[i]).format(table);}}function getWidgetById(name){var l=widgets.length;for(var i=0;i<l;i++){if(widgets[i].id.toLowerCase()==name.toLowerCase()){return widgets[i];}}};function formatSortingOrder(v){if(typeof(v)!="Number"){i=(v.toLowerCase()=="desc")?1:0;}else{i=(v==(0||1))?v:0;}return i;}function isValueInArray(v,a){var l=a.length;for(var i=0;i<l;i++){if(a[i][0]==v){return true;}}return false;}function setHeadersCss(table,$headers,list,css){$headers.removeClass(css[0]).removeClass(css[1]);var h=[];$headers.each(function(offset){if(!this.sortDisabled){h[this.column]=$(this);}});var l=list.length;for(var i=0;i<l;i++){h[list[i][0]].addClass(css[list[i][1]]);}}function fixColumnWidth(table,$headers){var c=table.config;if(c.widthFixed){var colgroup=$('<colgroup>');$("tr:first td",table.tBodies[0]).each(function(){colgroup.append($('<col>').css('width',$(this).width()));});$(table).prepend(colgroup);};}function updateHeaderSortCount(table,sortList){var c=table.config,l=sortList.length;for(var i=0;i<l;i++){var s=sortList[i],o=c.headerList[s[0]];o.count=s[1];o.count++;}}function multisort(table,sortList,cache){if(table.config.debug){var sortTime=new Date();}var dynamicExp="var sortWrapper = function(a,b) {",l=sortList.length;for(var i=0;i<l;i++){var c=sortList[i][0];var order=sortList[i][1];var s=(getCachedSortType(table.config.parsers,c)=="text")?((order==0)?"sortText":"sortTextDesc"):((order==0)?"sortNumeric":"sortNumericDesc");var e="e"+i;dynamicExp+="var "+e+" = "+s+"(a["+c+"],b["+c+"]); ";dynamicExp+="if("+e+") { return "+e+"; } ";dynamicExp+="else { ";}var orgOrderCol=cache.normalized[0].length-1;dynamicExp+="return a["+orgOrderCol+"]-b["+orgOrderCol+"];";for(var i=0;i<l;i++){dynamicExp+="}; ";}dynamicExp+="return 0; ";dynamicExp+="}; ";eval(dynamicExp);cache.normalized.sort(sortWrapper);if(table.config.debug){benchmark("Sorting on "+sortList.toString()+" and dir "+order+" time:",sortTime);}return cache;};function sortText(a,b){return((a<b)?-1:((a>b)?1:0));};function sortTextDesc(a,b){return((b<a)?-1:((b>a)?1:0));};function sortNumeric(a,b){return a-b;};function sortNumericDesc(a,b){return b-a;};function getCachedSortType(parsers,i){return parsers[i].type;};this.construct=function(settings){return this.each(function(){if(!this.tHead||!this.tBodies)return;var $this,$document,$headers,cache,config,shiftDown=0,sortOrder;this.config={};config=$.extend(this.config,$.tablesorter.defaults,settings);$this=$(this);$headers=buildHeaders(this);this.config.parsers=buildParserCache(this,$headers);cache=buildCache(this);var sortCSS=[config.cssDesc,config.cssAsc];fixColumnWidth(this);$headers.click(function(e){$this.trigger("sortStart");var totalRows=($this[0].tBodies[0]&&$this[0].tBodies[0].rows.length)||0;if(!this.sortDisabled&&totalRows>0){var $cell=$(this);var i=this.column;this.order=this.count++%2;if(!e[config.sortMultiSortKey]){config.sortList=[];if(config.sortForce!=null){var a=config.sortForce;for(var j=0;j<a.length;j++){if(a[j][0]!=i){config.sortList.push(a[j]);}}}config.sortList.push([i,this.order]);}else{if(isValueInArray(i,config.sortList)){for(var j=0;j<config.sortList.length;j++){var s=config.sortList[j],o=config.headerList[s[0]];if(s[0]==i){o.count=s[1];o.count++;s[1]=o.count%2;}}}else{config.sortList.push([i,this.order]);}};setTimeout(function(){setHeadersCss($this[0],$headers,config.sortList,sortCSS);appendToTable($this[0],multisort($this[0],config.sortList,cache));},1);return false;}}).mousedown(function(){if(config.cancelSelection){this.onselectstart=function(){return false};return false;}});$this.bind("update",function(){this.config.parsers=buildParserCache(this,$headers);cache=buildCache(this);}).bind("sorton",function(e,list){$(this).trigger("sortStart");config.sortList=list;var sortList=config.sortList;updateHeaderSortCount(this,sortList);setHeadersCss(this,$headers,sortList,sortCSS);appendToTable(this,multisort(this,sortList,cache));}).bind("appendCache",function(){appendToTable(this,cache);}).bind("applyWidgetId",function(e,id){getWidgetById(id).format(this);}).bind("applyWidgets",function(){applyWidget(this);});if($.metadata&&($(this).metadata()&&$(this).metadata().sortlist)){config.sortList=$(this).metadata().sortlist;}if(config.sortList.length>0){$this.trigger("sorton",[config.sortList]);}applyWidget(this);});};this.addParser=function(parser){var l=parsers.length,a=true;for(var i=0;i<l;i++){if(parsers[i].id.toLowerCase()==parser.id.toLowerCase()){a=false;}}if(a){parsers.push(parser);};};this.addWidget=function(widget){widgets.push(widget);};this.formatFloat=function(s){var i=parseFloat(s);return(isNaN(i))?0:i;};this.formatInt=function(s){var i=parseInt(s);return(isNaN(i))?0:i;};this.isDigit=function(s,config){var DECIMAL='\\'+config.decimal;var exp='/(^[+]?0('+DECIMAL+'0+)?$)|(^([-+]?[1-9][0-9]*)$)|(^([-+]?((0?|[1-9][0-9]*)'+DECIMAL+'(0*[1-9][0-9]*)))$)|(^[-+]?[1-9]+[0-9]*'+DECIMAL+'0+$)/';return RegExp(exp).test($.trim(s));};this.clearTableBody=function(table){if($.browser.msie){function empty(){while(this.firstChild)this.removeChild(this.firstChild);}empty.apply(table.tBodies[0]);}else{table.tBodies[0].innerHTML="";}};}});$.fn.extend({tablesorter:$.tablesorter.construct});var ts=$.tablesorter;ts.addParser({id:"text",is:function(s){return true;},format:function(s){return $.trim(s.toLowerCase());},type:"text"});ts.addParser({id:"digit",is:function(s,table){var c=table.config;return $.tablesorter.isDigit(s,c);},format:function(s){return $.tablesorter.formatFloat(s);},type:"numeric"});ts.addParser({id:"currency",is:function(s){return/^[£$€?.]/.test(s);},format:function(s){return $.tablesorter.formatFloat(s.replace(new RegExp(/[^0-9.]/g),""));},type:"numeric"});ts.addParser({id:"ipAddress",is:function(s){return/^\d{2,3}[\.]\d{2,3}[\.]\d{2,3}[\.]\d{2,3}$/.test(s);},format:function(s){var a=s.split("."),r="",l=a.length;for(var i=0;i<l;i++){var item=a[i];if(item.length==2){r+="0"+item;}else{r+=item;}}return $.tablesorter.formatFloat(r);},type:"numeric"});ts.addParser({id:"url",is:function(s){return/^(https?|ftp|file):\/\/$/.test(s);},format:function(s){return jQuery.trim(s.replace(new RegExp(/(https?|ftp|file):\/\//),''));},type:"text"});ts.addParser({id:"isoDate",is:function(s){return/^\d{4}[\/-]\d{1,2}[\/-]\d{1,2}$/.test(s);},format:function(s){return $.tablesorter.formatFloat((s!="")?new Date(s.replace(new RegExp(/-/g),"/")).getTime():"0");},type:"numeric"});ts.addParser({id:"percent",is:function(s){return/\%$/.test($.trim(s));},format:function(s){return $.tablesorter.formatFloat(s.replace(new RegExp(/%/g),""));},type:"numeric"});ts.addParser({id:"usLongDate",is:function(s){return s.match(new RegExp(/^[A-Za-z]{3,10}\.? [0-9]{1,2}, ([0-9]{4}|'?[0-9]{2}) (([0-2]?[0-9]:[0-5][0-9])|([0-1]?[0-9]:[0-5][0-9]\s(AM|PM)))$/));},format:function(s){return $.tablesorter.formatFloat(new Date(s).getTime());},type:"numeric"});ts.addParser({id:"shortDate",is:function(s){return/\d{1,2}[\/\-]\d{1,2}[\/\-]\d{2,4}/.test(s);},format:function(s,table){var c=table.config;s=s.replace(/\-/g,"/");if(c.dateFormat=="us"){s=s.replace(/(\d{1,2})[\/\-](\d{1,2})[\/\-](\d{4})/,"$3/$1/$2");}else if(c.dateFormat=="uk"){s=s.replace(/(\d{1,2})[\/\-](\d{1,2})[\/\-](\d{4})/,"$3/$2/$1");}else if(c.dateFormat=="dd/mm/yy"||c.dateFormat=="dd-mm-yy"){s=s.replace(/(\d{1,2})[\/\-](\d{1,2})[\/\-](\d{2})/,"$1/$2/$3");}return $.tablesorter.formatFloat(new Date(s).getTime());},type:"numeric"});ts.addParser({id:"time",is:function(s){return/^(([0-2]?[0-9]:[0-5][0-9])|([0-1]?[0-9]:[0-5][0-9]\s(am|pm)))$/.test(s);},format:function(s){return $.tablesorter.formatFloat(new Date("2000/01/01 "+s).getTime());},type:"numeric"});ts.addParser({id:"metadata",is:function(s){return false;},format:function(s,table,cell){var c=table.config,p=(!c.parserMetadataName)?'sortValue':c.parserMetadataName;return $(cell).metadata()[p];},type:"numeric"});ts.addWidget({id:"zebra",format:function(table){if(table.config.debug){var time=new Date();}$("tr:visible",table.tBodies[0]).filter(':even').removeClass(table.config.widgetZebra.css[1]).addClass(table.config.widgetZebra.css[0]).end().filter(':odd').removeClass(table.config.widgetZebra.css[0]).addClass(table.config.widgetZebra.css[1]);if(table.config.debug){$.tablesorter.benchmark("Applying Zebra widget",time);}}});})(jQuery);;
/* END /2static/script/lib/jquery/plugins/jquery.tablesorter-2.0.3.min.js */
/* START /2static/script/lib/jquery/plugins/jquery.metadata-2.0.min.js */
/*
 * Metadata - jQuery plugin for parsing metadata from elements
 *
 * Copyright (c) 2006 John Resig, Yehuda Katz, J�örn Zaefferer, Paul McLanahan
 *
 * Dual licensed under the MIT and GPL licenses:
 *   http://www.opensource.org/licenses/mit-license.php
 *   http://www.gnu.org/licenses/gpl.html
 *
 * Revision: $Id: jquery.metadata.js 3620 2007-10-10 20:55:38Z pmclanahan $
 *
 */
(function($){$.extend({metadata:{defaults:{type:'class',name:'metadata',cre:/({.*})/,single:'metadata'},setType:function(type,name){this.defaults.type=type;this.defaults.name=name;},get:function(elem,opts){var settings=$.extend({},this.defaults,opts);if(!settings.single.length)settings.single='metadata';var data=$.data(elem,settings.single);if(data)return data;data="{}";if(settings.type=="class"){var m=settings.cre.exec(elem.className);if(m)data=m[1];}else if(settings.type=="elem"){if(!elem.getElementsByTagName)return;var e=elem.getElementsByTagName(settings.name);if(e.length)data=$.trim(e[0].innerHTML);}else if(elem.getAttribute!=undefined){var attr=elem.getAttribute(settings.name);if(attr)data=attr;}if(data.indexOf('{')<0)data="{"+data+"}";data=eval("("+data+")");$.data(elem,settings.single,data);return data;}}});$.fn.metadata=function(opts){return $.metadata.get(this[0],opts);};})(jQuery);;
/* END /2static/script/lib/jquery/plugins/jquery.metadata-2.0.min.js */
/* START /2static/script/lib/jquery/plugins/jquery.scrollTo.js */
/**
 * jQuery.ScrollTo
 * Copyright (c) 2007-2009 Ariel Flesler - aflesler(at)gmail(dot)com | http://flesler.blogspot.com
 * Dual licensed under MIT and GPL.
 * Date: 3/9/2009
 *
 * @projectDescription Easy element scrolling using jQuery.
 * http://flesler.blogspot.com/2007/10/jqueryscrollto.html
 * Works with jQuery +1.2.6. Tested on FF 2/3, IE 6/7, Opera 9.5/6, Safari 3, Chrome 1 on WinXP.
 *
 * @author Ariel Flesler
 * @version 1.4.1
 *
 * @id jQuery.scrollTo
 * @id jQuery.fn.scrollTo
 * @param {String, Number, DOMElement, jQuery, Object} target Where to scroll the matched elements.
 *	  The different options for target are:
 *		- A number position (will be applied to all axes).
 *		- A string position ('44', '100px', '+=90', etc ) will be applied to all axes
 *		- A jQuery/DOM element ( logically, child of the element to scroll )
 *		- A string selector, that will be relative to the element to scroll ( 'li:eq(2)', etc )
 *		- A hash { top:x, left:y }, x and y can be any kind of number/string like above.
 * @param {Number} duration The OVERALL length of the animation, this argument can be the settings object instead.
 * @param {Object,Function} settings Optional set of settings or the onAfter callback.
 *	 @option {String} axis Which axis must be scrolled, use 'x', 'y', 'xy' or 'yx'.
 *	 @option {Number} duration The OVERALL length of the animation.
 *	 @option {String} easing The easing method for the animation.
 *	 @option {Boolean} margin If true, the margin of the target element will be deducted from the final position.
 *	 @option {Object, Number} offset Add/deduct from the end position. One number for both axes or { top:x, left:y }.
 *	 @option {Object, Number} over Add/deduct the height/width multiplied by 'over', can be { top:x, left:y } when using both axes.
 *	 @option {Boolean} queue If true, and both axis are given, the 2nd axis will only be animated after the first one ends.
 *	 @option {Function} onAfter Function to be called after the scrolling ends. 
 *	 @option {Function} onAfterFirst If queuing is activated, this function will be called after the first scrolling ends.
 * @return {jQuery} Returns the same jQuery object, for chaining.
 *
 * @desc Scroll to a fixed position
 * @example $('div').scrollTo( 340 );
 *
 * @desc Scroll relatively to the actual position
 * @example $('div').scrollTo( '+=340px', { axis:'y' } );
 *
 * @dec Scroll using a selector (relative to the scrolled element)
 * @example $('div').scrollTo( 'p.paragraph:eq(2)', 500, { easing:'swing', queue:true, axis:'xy' } );
 *
 * @ Scroll to a DOM element (same for jQuery object)
 * @example var second_child = document.getElementById('container').firstChild.nextSibling;
 *			$('#container').scrollTo( second_child, { duration:500, axis:'x', onAfter:function(){
 *				alert('scrolled!!');																   
 *			}});
 *
 * @desc Scroll on both axes, to different values
 * @example $('div').scrollTo( { top: 300, left:'+=200' }, { axis:'xy', offset:-20 } );
 */
;(function( $ ){
	
	var $scrollTo = $.scrollTo = function( target, duration, settings ){
		$(window).scrollTo( target, duration, settings );
	};

	$scrollTo.defaults = {
		axis:'xy',
		duration: parseFloat($.fn.jquery) >= 1.3 ? 0 : 1
	};

	// Returns the element that needs to be animated to scroll the window.
	// Kept for backwards compatibility (specially for localScroll & serialScroll)
	$scrollTo.window = function( scope ){
		return $(window).scrollable();
	};

	// Hack, hack, hack... stay away!
	// Returns the real elements to scroll (supports window/iframes, documents and regular nodes)
	$.fn.scrollable = function(){
		return this.map(function(){
			var elem = this,
				isWin = !elem.nodeName || $.inArray( elem.nodeName.toLowerCase(), ['iframe','#document','html','body'] ) != -1;

				if( !isWin )
					return elem;

			var doc = (elem.contentWindow || elem).document || elem.ownerDocument || elem;
			
			return $.browser.safari || doc.compatMode == 'BackCompat' ?
				doc.body : 
				doc.documentElement;
		});
	};

	$.fn.scrollTo = function( target, duration, settings ){
		if( typeof duration == 'object' ){
			settings = duration;
			duration = 0;
		}
		if( typeof settings == 'function' )
			settings = { onAfter:settings };
			
		if( target == 'max' )
			target = 9e9;
			
		settings = $.extend( {}, $scrollTo.defaults, settings );
		// Speed is still recognized for backwards compatibility
		duration = duration || settings.speed || settings.duration;
		// Make sure the settings are given right
		settings.queue = settings.queue && settings.axis.length > 1;
		
		if( settings.queue )
			// Let's keep the overall duration
			duration /= 2;
		settings.offset = both( settings.offset );
		settings.over = both( settings.over );

		return this.scrollable().each(function(){
			var elem = this,
				$elem = $(elem),
				targ = target, toff, attr = {},
				win = $elem.is('html,body');

			switch( typeof targ ){
				// A number will pass the regex
				case 'number':
				case 'string':
					if( /^([+-]=)?\d+(\.\d+)?(px)?$/.test(targ) ){
						targ = both( targ );
						// We are done
						break;
					}
					// Relative selector, no break!
					targ = $(targ,this);
				case 'object':
					// DOMElement / jQuery
					if( targ.is || targ.style )
						// Get the real position of the target 
						toff = (targ = $(targ)).offset();
			}
			$.each( settings.axis.split(''), function( i, axis ){
				var Pos	= axis == 'x' ? 'Left' : 'Top',
					pos = Pos.toLowerCase(),
					key = 'scroll' + Pos,
					old = elem[key],
					Dim = axis == 'x' ? 'Width' : 'Height';

				if( toff ){// jQuery / DOMElement
					attr[key] = toff[pos] + ( win ? 0 : old - $elem.offset()[pos] );

					// If it's a dom element, reduce the margin
					if( settings.margin ){
						attr[key] -= parseInt(targ.css('margin'+Pos)) || 0;
						attr[key] -= parseInt(targ.css('border'+Pos+'Width')) || 0;
					}
					
					attr[key] += settings.offset[pos] || 0;
					
					if( settings.over[pos] )
						// Scroll to a fraction of its width/height
						attr[key] += targ[Dim.toLowerCase()]() * settings.over[pos];
				}else
					attr[key] = targ[pos];

				// Number or 'number'
				if( /^\d+$/.test(attr[key]) )
					// Check the limits
					attr[key] = attr[key] <= 0 ? 0 : Math.min( attr[key], max(Dim) );

				// Queueing axes
				if( !i && settings.queue ){
					// Don't waste time animating, if there's no need.
					if( old != attr[key] )
						// Intermediate animation
						animate( settings.onAfterFirst );
					// Don't animate this axis again in the next iteration.
					delete attr[key];
				}
			});

			animate( settings.onAfter );			

			function animate( callback ){
				$elem.animate( attr, duration, settings.easing, callback && function(){
					callback.call(this, target, settings);
				});
			};

			// Max scrolling position, works on quirks mode
			// It only fails (not too badly) on IE, quirks mode.
			function max( Dim ){
				var scroll = 'scroll'+Dim;
				
				if( !win )
					return elem[scroll];
				
				var size = 'client' + Dim,
					html = elem.ownerDocument.documentElement,
					body = elem.ownerDocument.body;

				return Math.max( html[scroll], body[scroll] ) 
					 - Math.min( html[size]  , body[size]   );
					
			};

		}).end();
	};

	function both( val ){
		return typeof val == 'object' ? val : { top:val, left:val };
	};

})( jQuery );;
/* END /2static/script/lib/jquery/plugins/jquery.scrollTo.js */
