[#ftl]
[#include "fisheye-mail-subject.ftl"]

[#setting time_zone="${timezone}"]
[#include "fisheye-mail-header.ftl"]
[#list changesets as cs]
${cs.id} <${siteurl}changelog/${repname}?cs=${cs.id}>
${cs.dateValue?string("EEE, dd MMMM yyyy, HH:mm:ss ZZ")}
Author: ${cs.author}
Comment: ${cs.comment}
Files:
[#list cs.revisionInfos as rev]
[@compress single_line=true]
  ${rev.path} ${rev.revision}
  [#if rev.binary]
 binary
  [#else]
 ([#if !rev.dead]+${rev.linesAdded}[/#if][#if !rev.added]-${rev.linesRemoved}[/#if])
  [/#if]
  [#if rev.dead]
  deleted[#if rev.move]/moved[/#if][#if rev.copy]/copied[/#if]
  [#elseif rev.added]
  new[#if rev.move]/moved[/#if][#if rev.copy]/copied[/#if]
  [/#if]
[/@compress]
 [#nt]
[/#list]
-----
[/#list]

To delete watches go to ${siteurl}?dialog=${"/profile/showWatches.do"?url}

[#include "fisheye-mail-footer.ftl"]
