[#ftl]
---------------------------------------------------------
This is an automated support request sent from Fisheye
---------------------------------------------------------

Problem Description:
${description}

Environment Information:
  Version: ${version}
  FISHEYE_HOME: ${FISHEYE_HOME}
  FISHEYE_INST: ${FISHEYE_INST}
  Java Version: ${javaVersion}
  Java Vendor: ${javaVendor}
  JVM Version: ${jVMVersion}
  JVM Vendor: ${jVMVendor}
  JVM Impl Version: ${jVMImplementationVersion}
  Java Runtime: ${javaRuntimeName}
  Java VM: ${javaVMName}
  Operating System: ${oSInfo}
  OS Architecture: ${oSArch}
  User Timezone: ${userTimezone}
  JVM Input Args: ${jVMInputArguments}
  Total Memory: ${totalMemory}
  Free Memory: ${freeMemory}

License Information:
  [#if serverid?exists]
  Server ID: ${serverid}
  [#else]
  License ID
    FishEye: ${fePublicID}
    [#if cruPublicID?exists]
    Crucible: ${cruPublicID}
    [/#if]
  [/#if]
  Product: ${productName}
  License: ${licenseName}
  [#if cruLicenseName?exists]
  ${cruLicenseName}
  [/#if]
  Licensed To: ${licensedTo}
  Expires: ${expires}
  Upgrades/Maintenence: ${upgradesMaintenence}
  License Restrictions:
    ${maxFEUsers}
    [#if maxCruUsers?exists]
    ${maxCruUsers}
    [/#if]

Contact Information:
  Name: ${contactName}
  Email: ${contactEmail}
  Phone: ${contactNumber}
  [#if existingRequest?exists]
  Support Issue: ${existingRequest} 
  [/#if]
