if (!AJS.FECRU) {
    AJS.FECRU = {};
    AJS.FECRU.IE = {};
} else if (!AJS.FECRU.IE) {
    AJS.FECRU.IE = {};
}

// overcomes a layering/document flow issue where IE pushes this down under the ajax loaded content
// z-index or re-appending the element had no effect, moving it to the body means it comes after the ajax content in the flow
// needs to determine the top in JavaScript as slurps and alerts get injected in to the DOM and shift the 'top'
// to position any other items, add them to the array

AJS.FECRU.IE.reloadContenders = ["#context-navigation","#breadCrumb"];

AJS.FECRU.IE.reloadDOMElements = function () {
    AJS.$(AJS.FECRU.IE.reloadContenders).each(function (i) {
        var id = AJS.FECRU.IE.reloadContenders[i];
        var top = AJS.$(id).offset().top;

        var domShift = function (id, top) {
            AJS.$("body").append(AJS.$(id));
            AJS.$(id).css("top", top);
        };

        domShift(id, top);

   });
};

// overcomes IE bug where :hover is only available on A elements
// the toolbar applies :hovers to its child LIs and IE can't respond
AJS.FECRU.IE.emulateHover = function () {
    AJS.$("#content .toolbar li").mouseenter( function () {
            AJS.$(this).css({
                "background-color": "#6699CC",
                "color": "#FFFFFF"
            });
        }
     ).mouseleave( function () {
            AJS.$(this).css({
                "background-color": "transparent",
                "color": "#000000"
            });
        }
    );
    AJS.$("#content .toolbar li.disabled").mouseenter( function () {
            AJS.$(this).css({
                "background-color": "transparent",
                "color": "#BBBBBB",
                "cursor": "default"
            });
        }
     ).mouseleave( function () {
            AJS.$(this).css({
                "background-color": "transparent",
                "color": "#BBBBBB",
                "cursor": "default"
            });
        }
    );
    AJS.$("#content .toolbar li.toggle").mouseenter( function () {
            AJS.$(this).css({
                "background-color": "transparent",
                "color": "#000000"
            });
        }
     ).mouseleave( function () {
            AJS.$(this).css({
                "background-color": "transparent",
                "color": "#000000"
            });
        }
    );
};

/*
(function() {

})();

AJS.$(document).ready(function(){

});
*/
AJS.$(window).ready(function(){
    AJS.FECRU.IE.reloadDOMElements();
    AJS.FECRU.IE.emulateHover();
});
