//fisheye global.js
function feToggleNodeAndImage(nodeName, forceOpen, forceClose) {
  var node = AJS.$("#" + nodeName);
  if (node.length === 0) {
      return false;
  }
  var img = AJS.$("#" + nodeName + 'img');
  var open = node.is(":hidden");
  open = (!forceClose) && (forceOpen || open);
  if (open) {
    if (node.is(":hidden")) {
      node.show();
      img.attr("src", fishEyePageContext + '/' + fishEyeSTATICDIR + '/images/arrow_open.gif');
    }
  } else {
    if (node.is(":visible")) {
      node.hide();
      img.attr("src", fishEyePageContext + '/' + fishEyeSTATICDIR + '/images/arrow_closed.gif');
    }
  }
  return false;
}

function csToggleAllDiffs(ids, forceOpen, forceClose) {
  for (var i = 0; i < ids.length; i++) {
    toggleNodeAndImage(ids[i], forceOpen, forceClose);
  }
  return false;
}
function csExpandAllDiffs(ids) {
  csToggleAllDiffs(ids, true, false);
  return false;
}
function csCollapseAllDiffs(ids) {
  csToggleAllDiffs(ids, false, true);
  return false;
}

function toggleBasic(nodeName) {
    toggleNodeAndImage(nodeName, false, false, false);
}

function toggleNodeAndImage(nodeName, forceOpen, forceClose, inline) {
    var node = AJS.$("#" + nodeName);
    if (node.length === 0) {
        return false;
    }
    var img = AJS.$("#" + nodeName + 'img');
    var open = node.is(":hidden");
    open = (!forceClose) && (forceOpen || open);
    if (open) {
        if (node.is(":hidden")) {
            node.show();
            img.attr("src", fishEyePageContext + '/' + fishEyeSTATICDIR + '/images/arrow_open.gif');
        }
    } else if (node.is(":visible")) {
        node.hide();
        img.attr("src", fishEyePageContext + '/' + fishEyeSTATICDIR + '/images/arrow_closed.gif');
    }
    return false;
}
